<script setup lang="ts">
import { useStockStore } from "@/stores/stock";
import { ref } from "vue";
import type { VForm } from "vuetify/components";
const stockStore = useStockStore();
const form = ref<VForm | null>(null);

async function save() {
  const { valid } = await form.value!.validate();
  if (valid) {
    await stockStore.saveStocks();
  }
}

// const save = async () => {
//   const { valid } = await form.value!.validate();
//   if (valid) {
//     stockStore.saveStock();
//   }
// };

const clear = () => {
  stockStore.dialog = false;
  stockStore.clear();
};
</script>

<template>
  <v-row justify="center">
    <v-dialog v-model="stockStore.dialog" persistent width="1024">
      <v-card>
        <v-card-title>
          <span class="text-h5">Vegetable</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="form">
            <v-container>
              <v-row>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    label="Name*"
                    v-model="stockStore.editedStock.name"
                    :rules="[(v) => !!v || 'Name must not be null']"
                    required
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    label="Minimum*"
                    v-model.number="stockStore.editedStock.minimum"
                    :rules="[(v) => !!v || 'Minimum must not be null']"
                    required
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    label="Remainder*"
                    v-model.number="stockStore.editedStock.remain"
                    :rules="[(v) => !!v || 'Remainder must not be null']"
                    required
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    label="Unit*"
                    v-model="stockStore.editedStock.unit"
                    :rules="[(v) => !!v || 'Unit must not be null']"
                    required
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>

          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="clear">
            Close
          </v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<style scoped></style>
